----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2017/--/-- --:--:--
-- Design Name: 
-- Module Name: Divide_Clock - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.all;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Divide_Clock is
    port ( CLK : in  STD_LOGIC;
           RESET : in  STD_LOGIC;
           LD0 : out  STD_LOGIC);
end Divide_Clock;

architecture Behavioral of Divide_Clock is
	signal temp_count : STD_LOGIC_VECTOR (25 downto 0);
	signal temp : STD_LOGIC;
	signal enable : STD_LOGIC;
begin
	process (CLK, RESET)
	begin
		if (RESET = '1') then
			temp_count <= (others => '0');
		elsif (CLK' event and CLK = '1') then
			if (temp_count = 49999999) then
			--if (temp_count = 9) then
				temp_count <= (others => '0');
			else
				temp_count <= temp_count + '1';
			end if;
		end if;
	end process;

	enable <= '1' when temp_count = 0 else '0';
	
	process (CLK, RESET)
	begin
		if (RESET = '1') then
			temp <= '0';
		elsif (CLK' event and CLK = '1') then
			if (enable = '1') then
				temp <= not temp;
			end if;
		end if;
	end process;
	LD0 <= temp;
end Behavioral;

