----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2017/--/-- --:--:--
-- Design Name: 
-- Module Name: Decimal_Counter - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.all;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Decimal_Counter is
    port ( CLK : in  STD_LOGIC;
           RESET : in  STD_LOGIC;
           Q : out  STD_LOGIC_VECTOR (3 downto 0));
end Decimal_Counter;

architecture Behavioral of Decimal_Counter is
	signal temp_count : STD_LOGIC_VECTOR (25 downto 0);
	signal temp_q : STD_LOGIC_VECTOR (3 downto 0);
	signal inc : STD_LOGIC;
begin
	process (CLK, RESET)
	begin
		if (RESET = '1') then
			temp_count <= (others => '0');
		elsif (CLK' event and CLK = '1') then
			if (temp_count = 49999999) then
				temp_count <= (others => '0');
			else
				temp_count <= temp_count + '1';
			end if;
		end if;
	end process;
	
	inc <= '1' when temp_count = 0 else '0';
	
	process (CLK, RESET)
	begin
		if (RESET = '1') then
			temp_q <= (others => '0');
		elsif (CLK' event and CLK = '1') then
			if (inc = '1') then
				if (temp_q = 9) then
					temp_q <= (others => '0');
				else
					temp_q <= temp_q + '1';
				end if;
			end if;
		end if;
	end process;
	
	Q <= temp_q;
end Behavioral;

