`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2017/--/-- --:--:--
// Design Name: 
// Module Name: Counter_7seg
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module Counter_7seg(
    input CLK,
    input RESET,
    input [1:0] BTN,
    output [11:0] SEG
    );

	wire inc, dec;
	reg [3:0] ff;
	reg [19:0] temp_count;
	reg [1:0] out, buff;
	reg [11:0] temp_seg;
	
	always @(posedge CLK or posedge RESET)
	begin
		if (RESET)
			temp_count <= 0;
		else
			temp_count <= temp_count + 1;
	end
	
	always @(posedge CLK)
		if (temp_count == 0)
			out <= BTN;
	
	always @(posedge CLK or posedge RESET)
	begin
		if (RESET)
			buff <= 0;
		else
			buff <= out;
	end
	
	assign inc = out[0] & ~buff[0];
	assign dec = out[1] & ~buff[1];
	
	always @(posedge CLK or posedge RESET)
	begin
		if (RESET)
			ff <= 0;
		else if (inc == 1)
			if (ff == 9)
				ff <= 0;
			else
				ff <= ff + 1;
		else if (dec == 1)
			if (ff == 0)
				ff <= 9;
			else
				ff <= ff -1;
	end
	
	always @(ff)
	begin
		case (ff)
			4'b0000:temp_seg <= 12'b1110_1_1000000; //0
			4'b0001:temp_seg <= 12'b1110_1_1111001; //1
			4'b0010:temp_seg <= 12'b1110_1_0100100; //2
			4'b0011:temp_seg <= 12'b1110_1_0110000; //3
			4'b0100:temp_seg <= 12'b1110_1_0011001; //4
			4'b0101:temp_seg <= 12'b1110_1_0010010; //5
			4'b0110:temp_seg <= 12'b1110_1_0000010; //6
			4'b0111:temp_seg <= 12'b1110_1_1011000; //7
			4'b1000:temp_seg <= 12'b1110_1_0000000; //8
			4'b1001:temp_seg <= 12'b1110_1_0010000; //9
			default:temp_seg <= 12'b1111_1_1111111; //
		endcase
	end
	
	assign SEG = temp_seg;

endmodule

